100 REMark convert QL mode 32 screen or _PIC to .BMP
110 CLS : CLS #0
120 INPUT #0,'Source filename > ';ip$
130 INPUT #0,'Output filename > ';op$
140 INPUT #0,'1=Screen, 2=PIC > ';ptype
150 ql_flen = FLEN(\ip$) : REMark length of original QL file
160 IF ptype = 1 THEN
170   INPUT #0,'Pixel width > ';pw%;' height > ';ph%
180   ql_bpl = ql_flen DIV ph%
190 ELSE
200   REMark extract information from PIC file
210   OPEN_IN #3,ip$ : GET #3,v% : REMark $4AFC identifier
220   IF NOT(v% = 19196) THEN
230     CLOSE #3 : PRINT #0,'Not a PIC file!' : STOP
240   END IF
250   GET #3,pw% : REMark pixel width
260   GET #3,ph% : REMark pixel height
270   GET #3,tmp% : ql_bpl = tmp% : REMark bytes per line in QL file
280   ql_mode% = CODE(INKEY$(#3)) : REMark look for MODE 32
290   CLOSE #3
300   IF ql_mode% <> 32 THEN PRINT #0,'Not a MODE 32 picture!' : STOP
310 END IF
320 pc_bpl = 3*pw%
330 IF (pc_bpl MOD 4)<> 0 THEN pc_bpl = pc_bpl+4-(pc_bpl MOD 4)
340 pc_flen = 54+(pc_bpl*ph%)
350 base = ALCHP(ql_flen+4+pc_flen)
360 IF base < 0 THEN PRINT #0,'Out of memory.' : STOP
370 LBYTES ip$,base
380 ql_addr = base+(10*(ptype=2)) : REMark skip PIC file header?
390 REMark lines are stored BACKWARDS in .BMP files
400 ql_addr = ql_addr+((ph%-1)*ql_bpl)
410 pc_addr = base+ql_flen+4+54 : pc_addr = pc_addr+(pc_addr MOD 2)
420 FOR y = 0 TO ph%-1
430   AT 0,0 : PRINT y+1;'/';ph%
440   qlad = ql_addr
450   pcad = pc_addr
460   FOR x = 0 TO pw%-1
470     blue = PEEK(qlad)&&31 : REMark 0-31 for blue
480     red  = (PEEK(qlad+1)&&248)DIV 8 : REMark 0-31 for red
490     green= ((PEEK(qlad)&&224)DIV 4)||(PEEK(qlad+1)&&7): REMark 0-63 for green
500     POKE pcad,(8*(blue+1))-1 : POKE pcad+1,(4*(green+1))-1 : POKE pcad+2,(8*(red+1))-1
510     qlad = qlad+2
520     pcad = pcad+3
530   END FOR x
540   ql_addr = ql_addr - ql_bpl
550   pc_addr = pc_addr + pc_bpl
560 END FOR y
570 REMark build the .BMP 54 byte file header
580 buf = base+ql_flen
590 pc_addr = buf+4
600 :
610 REMark Bitmap File Header information section
620 POKE pc_addr,CODE('B') : POKE pc_addr+1,CODE('M')
630 Intel_POKE_L pc_addr+2,pc_flen,buf : REMark file length
640 Intel_POKE_W pc_addr+6,0,buf : REMark reserved
650 Intel_POKE_W pc_addr+8,0,buf : REMark reserved
660 Intel_POKE_L pc_addr+10,54,buf : REMark offset to start of graphics
670 :
680 REMark Bitmap Info section
690 Intel_POKE_L pc_addr+14,40,buf  : REMark length of this section
700 Intel_POKE_L pc_addr+18,pw%,buf : REMark pixel width
710 Intel_POKE_L pc_addr+22,ph%,buf : REMark pixel height
720 Intel_POKE_W pc_addr+26,1,buf   : REMark planes
730 Intel_POKE_W pc_addr+28,24,buf  : REMark 24 bits per pixel
740 Intel_POKE_L pc_addr+30,0,buf   : REMark uncompressed
750 Intel_POKE_L pc_addr+34,pc_flen-54,buf : REMark image size without hea
760 Intel_POKE_L pc_addr+38,5905    : REMark x pels per metre (150dpi)
770 Intel_POKE_L pc_addr+42,5905    : REMark y pels per metre (150dpi)
780 Intel_POKE_L pc_addr+46,0       : REMark use max. colours
790 Intel_POKE_L pc_addr+50,0       : REMark all colours important
800 :
810 PRINT #0,'Saving'!op$
820 :
830 pc_base = base+ql_flen+4 : pc_base = pc_base+(pc_base MOD 2)
840 SBYTES op$,pc_base,pc_flen
850 :
860 PRINT #0,'Program finished.'
870 STOP
880 :
890 DEFine PROCedure Intel_POKE_L (addr,value,buffer)
900   LOCal a
910   POKE_L buffer,value
920   FOR a = 0 TO 3 : POKE addr+a,PEEK(buffer+3-a)
930 END DEFine Intel_POKE_L
940 :
950 DEFine PROCedure Intel_POKE_W (addr,value,buffer)
960   POKE_W buffer,value
970   POKE addr,PEEK(buffer+1)
980   POKE addr+1,PEEK(buffer)
990 END DEFine Intel_POKE_W
